# Node.JS Quick Start

1.[Executing Node.js Scripts](#1-executing-nodejs-scripts)

2.[Node Package Manager](#2-node-package-manager)

3.[Create a simple http server](#3-Create-a-simple-http-server)



## 1- Executing Node.js Scripts

Create a new folder named lab1.1 into your workspace. In this folder create a file named helloworld.js and edit file content as shown below:

```js
helloworld.js
console.log("hello world");
```

Open a command prompt window and switch to test folder. Type

```unix
node helloworld.js
```

You will see "hello world message" on the screen

## 2- Node Package Manager

1. Open  [https://www.npmjs.com](https://www.npmjs.com) site and search/find some packages. Example: express, mongoose, connect, …

2. Open a command prompt window and switch to lab1.1 folder. Type

```unix
npm help
```

3. You will see command list. If you want to get help about specific term, type "npm help <term>". To try this type following commands:

```shell
npm help install
npm help package.json
```

4. Let install a package. Type 

```shell
npm install express
```

5. Examine  lab1.1 folder. You will see newly added "node_modules" folder. Examine inside of that folder.

6. Type "npm ls" to list installed packages

7. To remove a package uninstall command can be used. Type

```shell
npm uninstall express
```

After that check node_modules folder again. What is the difference?

8. To globally install packages, use –g option. Type following command:

```shell
npm install -g express
```

Go to global file location and test existence of the express module
Sample url: "C:\Users\Esma\AppData\Roaming\npm\node_modules"

9. Type "npm ls -g"  to list globally installed packages

10. Uninstall globally installed express module with:

```shell
npm uninstall -g express
```

## 3- Create a simple http server

1- In the lab1.1 folder create a new js file named sample.js
2- Edit file content as shown below:

```javascript
var http = require("http");
var server = http.createServer(function(request, response) {
response.write("Hello Node.js !!");
response.end();
});
server.listen(3000);
console.log('Server started');
```

3- Type "node sample.js" to run file.

4- Open a browser and type "localhost:3000". You should see the welcome message on the screen

![Success](images/success.png)
